# Class Inet4Address

java.lang.Object
java.net.InetAddress
java.net.Inet4Address

All Implemented Interfaces:
  `Serializable`

public final class Inet4Address extends InetAddress
This class represents an Internet Protocol version 4 (IPv4) address. Defined by RFC 790: Assigned Numbers, RFC 1918: Address Allocation for Private Internets, and RFC 2365: Administratively Scoped IP Multicast

## Textual representation of IPv4 addresses

Textual representation of IPv4 address used as input to methods takes one of the following forms:

> - `d.d.d.d`
> - `d.d.d`
> - `d.d`
> - `d`

When four parts are specified, each is interpreted as a byte of data and assigned, from left to right, to the four bytes of an IPv4 address.

When a three part address is specified, the last part is interpreted as a 16-bit quantity and placed in the right most two bytes of the network address. This makes the three part address format convenient for specifying Class B network addresses as 128.net.host.

When a two part address is supplied, the last part is interpreted as a 24-bit quantity and placed in the right most three bytes of the network address. This makes the two part address format convenient for specifying Class A network addresses as net.host.

When only one part is given, the value is stored directly in the network address without any byte rearrangement.

For example, the following (decimal) forms are supported by the methods `ofLiteral(String)` and `InetAddress.getByName(String)` which are capable of parsing textual representations of IPv4 addresses:

     // Dotted-decimal 'd.d.d.d' form with four part address literal
     InetAddress.getByName("007.008.009.010"); // ==> /7.8.9.10
     InetAddress.getByName("127.0.1.1");       // ==> /127.0.1.1

     // Dotted-decimal 'd.d.d' form with three part address literal,
     // the last part is placed in the right most two bytes
     // of the constructed address
     InetAddress.getByName("127.0.257"); // ==> /127.0.1.1

     // Dotted-decimal 'd.d' form with two part address literal,
     // the last part is placed in the right most three bytes
     // of the constructed address
     Inet4Address.ofLiteral("127.257"); // ==> /127.0.1.1

     // 'd' form with one decimal value that is stored directly in
     // the constructed address bytes without any rearrangement
     Inet4Address.ofLiteral("02130706689"); // ==> /127.0.1.1

The above forms adhere to "strict" decimal-only syntax. Additionally, the `ofPosixLiteral(String)` method implements a POSIX `inet_addr` compatible "loose" parsing algorithm, allowing octal and hexadecimal address segments. Please refer to RFC 6943: Issues in Identifier Comparison for Security Purposes. Aside from `Inet4Address.ofPosixLiteral(String)`, all methods only support strict decimal parsing.

For methods that return a textual representation as output value, the first form, i.e. a dotted-quad string in strict decimal notation, is used.

### The Scope of a Multicast Address

Historically the IPv4 TTL field in the IP header has doubled as a multicast scope field: a TTL of 0 means node-local, 1 means link-local, up through 32 means site-local, up through 64 means region-local, up through 128 means continent-local, and up through 255 are global. However, the administrative scoping is preferred. Please refer to RFC 2365: Administratively Scoped IP Multicast

Since:
  1.4
External Specifications
  - RFC 1918: Address Allocation for Private Internets
  - RFC 2365: Administratively Scoped IP Multicast
  - RFC 790: Assigned numbers
  - RFC 6943: Issues in Identifier Comparison for Security Purposes
See Also:
  - Serialized Form

## Method Summary

Modifier and Type
Method
Description
`boolean`
`equals(Object obj)`
Compares this object against the specified object.
`byte[]`
`getAddress()`
Returns the raw IP address of this `InetAddress` object.
`String`
`getHostAddress()`
Returns the IP address string in textual presentation form.
`int`
`hashCode()`
Returns a hashcode for this IP address.
`boolean`
`isAnyLocalAddress()`
Utility routine to check if the InetAddress is a wildcard address.
`boolean`
`isLinkLocalAddress()`
Utility routine to check if the InetAddress is a link local address.
`boolean`
`isLoopbackAddress()`
Utility routine to check if the InetAddress is a loopback address.
`boolean`
`isMCGlobal()`
Utility routine to check if the multicast address has global scope.
`boolean`
`isMCLinkLocal()`
Utility routine to check if the multicast address has link scope.
`boolean`
`isMCNodeLocal()`
Utility routine to check if the multicast address has node scope.
`boolean`
`isMCOrgLocal()`
Utility routine to check if the multicast address has organization scope.
`boolean`
`isMCSiteLocal()`
Utility routine to check if the multicast address has site scope.
`boolean`
`isMulticastAddress()`
Utility routine to check if the InetAddress is an IP multicast address.
`boolean`
`isSiteLocalAddress()`
Utility routine to check if the InetAddress is a site local address.
`static Inet4Address`
`ofLiteral(String ipv4AddressLiteral)`
Creates an `Inet4Address` based on the provided textual representation of an IPv4 address.
`static Inet4Address`
`ofPosixLiteral(String posixIPAddressLiteral)`
Creates an `Inet4Address` based on the provided textual representation of an IPv4 address in POSIX `inet_addr` compatible form.

### Methods declared in class InetAddress

`getAllByName, getByAddress, getByAddress, getByName, getCanonicalHostName, getHostName, getLocalHost, getLoopbackAddress, isReachable, isReachable, toString`

### Methods declared in class Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

## Method Details

### ofLiteral

public static Inet4Address ofLiteral(String ipv4AddressLiteral)
Creates an `Inet4Address` based on the provided textual representation of an IPv4 address.

If the provided IPv4 address literal cannot represent a valid IPv4 address an `IllegalArgumentException` is thrown.

This method doesn't block, i.e. no reverse lookup is performed.

Parameters:
  `ipv4AddressLiteral` - the textual representation of an IPv4 address.
Returns:
  an `Inet4Address` object with no hostname set, and constructed from the provided IPv4 address literal.
Throws:
  `IllegalArgumentException` - if the `ipv4AddressLiteral` cannot be parsed as an IPv4 address literal.
  `NullPointerException` - if the `ipv4AddressLiteral` is `null`.
Since:
  22

### ofPosixLiteral

public static Inet4Address ofPosixLiteral(String posixIPAddressLiteral)
Creates an `Inet4Address` based on the provided textual representation of an IPv4 address in POSIX `inet_addr` compatible form.

The method `ofPosixLiteral` implements POSIX `inet_addr` compatible parsing algorithm, allowing octal and hexadecimal address segments. `"0"` is the prefix for octal numbers, `"0x"` and `"0X"` are the prefixes for hexadecimal numbers. Non-zero address segments that start from non-zero digits are parsed as decimal numbers. The following (non-decimal) forms are supported by this method:

     // Dotted-quad 'x.x.x.x' form with four part address literal
     Inet4Address.ofPosixLiteral("0177.0.0.1"); // ==> /127.0.0.1
     Inet4Address.ofPosixLiteral("0x7F.0.0.1"); // ==> /127.0.0.1

     // Dotted-triple 'x.x.x' form with three part address literal,
     // the last part is placed in the rightmost two bytes
     // of the constructed address
     Inet4Address.ofPosixLiteral("0177.0.0402"); // ==> /127.0.1.2
     Inet4Address.ofPosixLiteral("0x7F.0.0x102"); // ==> /127.0.1.2

     // Dotted-double 'x.x' form with two part address literal,
     // the last part is placed in the rightmost three bytes
     // of the constructed address
     Inet4Address.ofPosixLiteral("0177.0201003"); // ==> /127.1.2.3
     Inet4Address.ofPosixLiteral("0x7F.0x10203"); // ==> /127.1.2.3
     Inet4Address.ofPosixLiteral("127.66051"); // ==> /127.1.2.3

     // Dotless 'x' form with one value that is stored directly in
     // the constructed address bytes without any rearrangement
     Inet4Address.ofPosixLiteral("0100401404"); // ==> /1.2.3.4
     Inet4Address.ofPosixLiteral("0x1020304"); // ==> /1.2.3.4
     Inet4Address.ofPosixLiteral("16909060"); // ==> /1.2.3.4

If the provided IPv4 address literal cannot represent a valid IPv4 address in POSIX form an `IllegalArgumentException` is thrown.

This method doesn't block, i.e. no hostname lookup is performed.

API Note:
  This method produces different results compared to ofLiteral(String) when `posixIPAddressLiteral` parameter contains address segments with leading zeroes. An address segment with a leading zero is always parsed as an octal number by this method, therefore `0255` (octal) will be parsed as `173` (decimal). On the other hand, `Inet4Address.ofLiteral` ignores leading zeros, parses all numbers as decimal and produces `255`. Where this method would parse `0256.0256.0256.0256` (octal) and produce `174.174.174.174` (decimal) in four dotted quad notation, `Inet4Address.ofLiteral` will throw `IllegalArgumentException`.
Parameters:
  `posixIPAddressLiteral` - a textual representation of an IPv4 address.
Returns:
  an `Inet4Address` object with no hostname set, and constructed from the provided IPv4 address literal.
Throws:
  `IllegalArgumentException` - if the `posixIPAddressLiteral` cannot be parsed as an IPv4 address literal.
  `NullPointerException` - if the `posixIPAddressLiteral` is `null`.
Since:
  23

### isMulticastAddress

public boolean isMulticastAddress()
Utility routine to check if the InetAddress is an IP multicast address. IP multicast address is a Class D address i.e first four bits of the address are 1110.

Overrides:
  `isMulticastAddress` in class `InetAddress`
Returns:
  a `boolean` indicating if the InetAddress is an IP multicast address

### isAnyLocalAddress

public boolean isAnyLocalAddress()
Utility routine to check if the InetAddress is a wildcard address.

Overrides:
  `isAnyLocalAddress` in class `InetAddress`
Returns:
  a `boolean` indicating if the InetAddress is a wildcard address.

### isLoopbackAddress

public boolean isLoopbackAddress()
Utility routine to check if the InetAddress is a loopback address.

Overrides:
  `isLoopbackAddress` in class `InetAddress`
Returns:
  a `boolean` indicating if the InetAddress is a loopback address; or false otherwise.

### isLinkLocalAddress

public boolean isLinkLocalAddress()
Utility routine to check if the InetAddress is a link local address.

Overrides:
  `isLinkLocalAddress` in class `InetAddress`
Returns:
  a `boolean` indicating if the InetAddress is a link local address; or false if address is not a link local unicast address.

### isSiteLocalAddress

public boolean isSiteLocalAddress()
Utility routine to check if the InetAddress is a site local address.

Overrides:
  `isSiteLocalAddress` in class `InetAddress`
Returns:
  a `boolean` indicating if the InetAddress is a site local address; or false if address is not a site local unicast address.

### isMCGlobal

public boolean isMCGlobal()
Utility routine to check if the multicast address has global scope.

Overrides:
  `isMCGlobal` in class `InetAddress`
Returns:
  a `boolean` indicating if the address has is a multicast address of global scope, false if it is not of global scope or it is not a multicast address

### isMCNodeLocal

public boolean isMCNodeLocal()
Utility routine to check if the multicast address has node scope.

Overrides:
  `isMCNodeLocal` in class `InetAddress`
Returns:
  a `boolean` indicating if the address has is a multicast address of node-local scope, false if it is not of node-local scope or it is not a multicast address

### isMCLinkLocal

public boolean isMCLinkLocal()
Utility routine to check if the multicast address has link scope.

Overrides:
  `isMCLinkLocal` in class `InetAddress`
Returns:
  a `boolean` indicating if the address has is a multicast address of link-local scope, false if it is not of link-local scope or it is not a multicast address

### isMCSiteLocal

public boolean isMCSiteLocal()
Utility routine to check if the multicast address has site scope.

Overrides:
  `isMCSiteLocal` in class `InetAddress`
Returns:
  a `boolean` indicating if the address has is a multicast address of site-local scope, false if it is not of site-local scope or it is not a multicast address

### isMCOrgLocal

public boolean isMCOrgLocal()
Utility routine to check if the multicast address has organization scope.

Overrides:
  `isMCOrgLocal` in class `InetAddress`
Returns:
  a `boolean` indicating if the address has is a multicast address of organization-local scope, false if it is not of organization-local scope or it is not a multicast address

### getAddress

public byte[] getAddress()
Returns the raw IP address of this `InetAddress` object. The result is in network byte order: the highest order byte of the address is in `getAddress()[0]`.

Overrides:
  `getAddress` in class `InetAddress`
Returns:
  the raw IP address of this object.

### getHostAddress

public String getHostAddress()
Returns the IP address string in textual presentation form.

Overrides:
  `getHostAddress` in class `InetAddress`
Returns:
  the raw IP address in a string format.

### hashCode

public int hashCode()
Returns a hashcode for this IP address.

Overrides:
  `hashCode` in class `InetAddress`
Returns:
  a hash code value for this IP address.
See Also:
  - `Object.equals(java.lang.Object)`
  - `System.identityHashCode(Object)`

### equals

public boolean equals(Object obj)
Compares this object against the specified object. The result is `true` if and only if the argument is not `null` and it represents the same IP address as this object.

Two instances of `InetAddress` represent the same IP address if the length of the byte arrays returned by `getAddress` is the same for both, and each of the array components is the same for the byte arrays.

Overrides:
  `equals` in class `InetAddress`
Parameters:
  `obj` - the object to compare against.
Returns:
  `true` if the objects are the same; `false` otherwise.
See Also:
  - `InetAddress.getAddress()`